/*
 * bq2jBible:   "  "   j
 *   9  2007 ., 1   26  2007
 */

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import java.util.*;
import java.util.zip.*;
import java.util.jar.*;

/**
 *   "  "
 * @author   webmaster@biblelamp.ru, 8-918-557-2926
 */
public class bq2jBible extends javax.swing.JFrame implements java.awt.event.ActionListener {

    /**  
     */
    public static final String APP_TITLE = " BQ->jBible";
    
    /**  
     */
    public static final String APP_VERSION = "1.10";
    
    /**  
     */
    public static final String APP_DATE = "24.12.2007";
    
    /**   jBible
     */
    public static final String JBIBLE_VERSION = "1.3.15";
    
    /**  
     */
    public static final String APP_DESCRIPTION =
        "  "+
        "\n      jBible"+
        "\n(   ,  "+JBIBLE_VERSION+")";
    
    /**  
     */
    public static final String APP_DEVELOPERS = "  (http://rostovchurch.ru)";
    
    /**     
     */
    public static final String APP_DEVELOPERS_CONTACT = "webmaster@biblelamp.ru";
    
    /** JAR    jBible
     */
    public static final String JBIBLE_JAR = "bq2jbible.jar";
    
    /**     jBible
     */
    public static final String MOBILE_DIR = "mobile/";
    
    /**    
     */
    public static final String BIBLE_INDEX = "bible/index";
    
    /**  
     */
    public static final String JBIBLE_ICON = "mobile/imgs/jBible.png";
    
    /**       
     */
    public static final String BQ_INI = "BibleQT.ini";
    
    /**    
     */
    public static final String BQ_DIR = "C:/Program files/BibleQuote/";

    /**    
     */
    private JCheckBox[] checkBooks;
    
    /**   
     */
    private boolean isBible;
    
    /**    
     */
    private boolean isStrongNumbers;
    
    /**   
     */
    private String chapterSign;

    /**   
     */
    private String verseSign;

    /**   
     */
    private String pathName;

    /**    
     */
    private String chapterQty;

    /**    c    
     */
    private String pathBQModule;

    /**   
     */
    private JFileChooser chooserOpen = new JFileChooser();

     /** ,   bibleqt.ini
     */
    private FileFilter filterBQ = new FileFilter() {

        public boolean accept(File f) {
            if(f.isDirectory()) return true;
            String name = f.getName().toLowerCase();
            return name.equalsIgnoreCase(BQ_INI);
        }

        public String getDescription() {
            return " "+BQ_INI;
        }
    };

    /**    bq2jBible
     */
    public bq2jBible() {
        initComponents();
        setTitle(APP_TITLE+"  "+APP_VERSION+"  "+APP_DATE); //  
        //    jbible.jar  
        File f = new File(JBIBLE_JAR);
        if (!f.exists()) {
            btnOpen.setEnabled(false);
            txtStatus.setText("  "+JBIBLE_JAR+"  .   .");
        } else txtStatus.setText(" .");
        chooserOpen.setFileSelectionMode(JFileChooser.FILES_ONLY);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        groupChoice = new javax.swing.ButtonGroup();
        btnExit = new javax.swing.JButton();
        btnOpen = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();
        btnAbout = new javax.swing.JButton();
        panelModule = new javax.swing.JPanel();
        txtPath = new javax.swing.JTextField();
        labelPath = new javax.swing.JLabel();
        labelModuleName = new javax.swing.JLabel();
        txtModuleName = new javax.swing.JTextField();
        scrollBooks = new javax.swing.JScrollPane();
        panelBooks = new javax.swing.JPanel();
        panelMidlet = new javax.swing.JPanel();
        labelMidletName = new javax.swing.JLabel();
        txtMidletName = new javax.swing.JTextField();
        labelChoice = new javax.swing.JLabel();
        radioChoice1 = new javax.swing.JRadioButton();
        radioChoice4 = new javax.swing.JRadioButton();
        radioChoice3 = new javax.swing.JRadioButton();
        radioChoice2 = new javax.swing.JRadioButton();
        txtStatus = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u041a\u043e\u043d\u0432\u0435\u0440\u0442\u043e\u0440 \u043c\u043e\u0434\u0443\u043b\u0435\u0439 BQ \u0434\u043b\u044f j\u0411\u0438\u0431\u043b\u0438\u0438");
        setBounds(new java.awt.Rectangle(150, 120, 0, 0));
        setResizable(false);
        btnExit.setText("\u0412\u044b\u0445\u043e\u0434");
        btnExit.addActionListener(this);

        btnOpen.setText("\u041e\u0442\u043a\u0440\u044b\u0442\u044c");
        btnOpen.addActionListener(this);

        btnSave.setText("\u0417\u0430\u043f\u0438\u0441\u0430\u0442\u044c");
        btnSave.setEnabled(false);
        btnSave.addActionListener(this);

        btnAbout.setText("\u041e \u043f\u0440\u043e\u0433\u0440\u0430\u043c\u043c\u0435");
        btnAbout.setMargin(new java.awt.Insets(2, 5, 2, 5));
        btnAbout.addActionListener(this);

        panelModule.setBorder(javax.swing.BorderFactory.createTitledBorder("\u041c\u043e\u0434\u0443\u043b\u044c \u0426\u0438\u0442\u0430\u0442\u044b \u0438\u0437 \u0411\u0438\u0431\u043b\u0438\u0438"));
        txtPath.setEditable(false);

        labelPath.setText("\u041f\u0443\u0442\u044c:");

        labelModuleName.setText("\u041e\u043f\u0438\u0441\u0430\u043d\u0438\u0435:");

        txtModuleName.setEditable(false);

        org.jdesktop.layout.GroupLayout panelModuleLayout = new org.jdesktop.layout.GroupLayout(panelModule);
        panelModule.setLayout(panelModuleLayout);
        panelModuleLayout.setHorizontalGroup(
            panelModuleLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelModuleLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelModuleLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(labelPath)
                    .add(labelModuleName))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelModuleLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, txtPath, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 392, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, txtModuleName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 392, Short.MAX_VALUE))
                .addContainerGap())
        );
        panelModuleLayout.setVerticalGroup(
            panelModuleLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelModuleLayout.createSequentialGroup()
                .add(panelModuleLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(labelPath)
                    .add(txtPath, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelModuleLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(labelModuleName)
                    .add(txtModuleName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout panelBooksLayout = new org.jdesktop.layout.GroupLayout(panelBooks);
        panelBooks.setLayout(panelBooksLayout);
        panelBooksLayout.setHorizontalGroup(
            panelBooksLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 379, Short.MAX_VALUE)
        );
        panelBooksLayout.setVerticalGroup(
            panelBooksLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 163, Short.MAX_VALUE)
        );
        scrollBooks.setViewportView(panelBooks);

        panelMidlet.setBorder(javax.swing.BorderFactory.createTitledBorder("\u041c\u043e\u0434\u0443\u043b\u044c j\u0411\u0438\u0431\u043b\u0438\u0438"));
        labelMidletName.setText("\u041d\u0430\u0437\u0432\u0430\u043d\u0438\u0435:");

        labelChoice.setText("\u0412\u044b\u0431\u0440\u0430\u0442\u044c:");

        groupChoice.add(radioChoice1);
        radioChoice1.setSelected(true);
        radioChoice1.setText("\u0432\u0441\u0435 \u043a\u043d\u0438\u0433\u0438");
        radioChoice1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        radioChoice1.setEnabled(false);
        radioChoice1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        radioChoice1.addActionListener(this);

        groupChoice.add(radioChoice4);
        radioChoice4.setText("\u043a\u0430\u043d\u043e\u043d\u0438\u0447\u0435\u0441\u043a\u0438\u0435");
        radioChoice4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        radioChoice4.setEnabled(false);
        radioChoice4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        radioChoice4.addActionListener(this);

        groupChoice.add(radioChoice3);
        radioChoice3.setText("\u041d\u043e\u0432\u044b\u0439 \u0417\u0430\u0432\u0435\u0442");
        radioChoice3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        radioChoice3.setEnabled(false);
        radioChoice3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        radioChoice3.addActionListener(this);

        groupChoice.add(radioChoice2);
        radioChoice2.setText("\u0438\u043d\u0432\u0435\u0440\u0441\u0438\u044f");
        radioChoice2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        radioChoice2.setEnabled(false);
        radioChoice2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        radioChoice2.addActionListener(this);

        org.jdesktop.layout.GroupLayout panelMidletLayout = new org.jdesktop.layout.GroupLayout(panelMidlet);
        panelMidlet.setLayout(panelMidletLayout);
        panelMidletLayout.setHorizontalGroup(
            panelMidletLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelMidletLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelMidletLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(labelMidletName)
                    .add(labelChoice))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelMidletLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(txtMidletName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 393, Short.MAX_VALUE)
                    .add(panelMidletLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(radioChoice1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(radioChoice2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(radioChoice3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(radioChoice4)))
                .addContainerGap())
        );
        panelMidletLayout.setVerticalGroup(
            panelMidletLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelMidletLayout.createSequentialGroup()
                .add(panelMidletLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(labelMidletName)
                    .add(txtMidletName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(panelMidletLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(labelChoice)
                    .add(radioChoice1)
                    .add(radioChoice3)
                    .add(radioChoice4)
                    .add(radioChoice2))
                .addContainerGap())
        );

        txtStatus.setEditable(false);
        txtStatus.setFont(new java.awt.Font("Tahoma", 1, 11));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelModule, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(panelMidlet, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(scrollBooks, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 383, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(btnOpen, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                                    .add(btnAbout, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, btnSave, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(btnExit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE))))
                .addContainerGap())
            .add(txtStatus, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 501, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelModule, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelMidlet, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(layout.createSequentialGroup()
                        .add(btnOpen)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSave)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnAbout)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(btnExit))
                    .add(scrollBooks, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 167, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(txtStatus, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        pack();
    }

    // Code for dispatching events from components to event handlers.

    public void actionPerformed(java.awt.event.ActionEvent evt) {
        if (evt.getSource() == btnExit) {
            bq2jBible.this.btnExitActionPerformed(evt);
        }
        else if (evt.getSource() == btnOpen) {
            bq2jBible.this.btnOpenActionPerformed(evt);
        }
        else if (evt.getSource() == btnSave) {
            bq2jBible.this.btnSaveActionPerformed(evt);
        }
        else if (evt.getSource() == btnAbout) {
            bq2jBible.this.btnAboutActionPerformed(evt);
        }
        else if (evt.getSource() == radioChoice1) {
            bq2jBible.this.radioChoice1ActionPerformed(evt);
        }
        else if (evt.getSource() == radioChoice4) {
            bq2jBible.this.radioChoice4ActionPerformed(evt);
        }
        else if (evt.getSource() == radioChoice3) {
            bq2jBible.this.radioChoice3ActionPerformed(evt);
        }
        else if (evt.getSource() == radioChoice2) {
            bq2jBible.this.radioChoice2ActionPerformed(evt);
        }
    }// </editor-fold>//GEN-END:initComponents

     /**   
     */
    private void btnAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAboutActionPerformed
        //ImageIcon icon = new ImageIcon(getClass().getResourceAsStream(JBIBLE_ICON));
        //ImageIcon icon = ImageIcon(ImageIO.read(getClass().getResourceAsStream(JBIBLE_ICON), "PNG"));
        JOptionPane.showMessageDialog(this,
            ": "+APP_TITLE+
            "\n: "+APP_VERSION+" ("+APP_DATE+")"+
            "\n\n: "+APP_DESCRIPTION+
            "\n\n: "+APP_DEVELOPERS+
            "\n: "+APP_DEVELOPERS_CONTACT,
            "  ",
            JOptionPane.INFORMATION_MESSAGE);
            //icon);
            //this.getClass().getResourceAsStream(JBIBLE_ICON));
    }//GEN-LAST:event_btnAboutActionPerformed

    /**     -
     */
    //  
    private void radioChoice1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioChoice1ActionPerformed
        for(int i=0;i<checkBooks.length;i++)
            checkBooks[i].setSelected(true);
    }//GEN-LAST:event_radioChoice1ActionPerformed
    //   ( 66)
    private void radioChoice4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioChoice4ActionPerformed
        for(int i=0;i<checkBooks.length;i++)
            if (i<66) checkBooks[i].setSelected(true);
            else checkBooks[i].setSelected(false);
    }//GEN-LAST:event_radioChoice4ActionPerformed
    //   
    private void radioChoice3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioChoice3ActionPerformed
        if (checkBooks.length<27)
            for(int i=0;i<checkBooks.length;i++)
                checkBooks[i].setSelected(true);
        else
            for(int i=0;i<checkBooks.length;i++)
                if ((i>38)&&(i<66)) checkBooks[i].setSelected(true);
                else checkBooks[i].setSelected(false);
        txtMidletName.setText(" "); //   
    }//GEN-LAST:event_radioChoice3ActionPerformed
    // 
    private void radioChoice2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioChoice2ActionPerformed
        for(int i=0;i<checkBooks.length;i++)
            checkBooks[i].setSelected(!checkBooks[i].isSelected());
        if (checkBooks.length>26)
            if (txtMidletName.getText().startsWith(" ")) 
                txtMidletName.setText(" ");
            else 
                if (txtMidletName.getText().startsWith(" ")) 
                    txtMidletName.setText(" ");
    }//GEN-LAST:event_radioChoice2ActionPerformed

     /**     ""
     */
    private void btnOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOpenActionPerformed
        try {
            File d = new File(BQ_DIR);
            if(d.isDirectory()) chooserOpen.setCurrentDirectory(d);
            chooserOpen.setFileFilter(filterBQ);
            chooserOpen.setDialogTitle("  "+BQ_INI);
            //chooserOpen.setCurrentDirectory("C:/Program files/BibleQuote/");
            int result = chooserOpen.showOpenDialog(this);
            if(result == JFileChooser.APPROVE_OPTION) {
                File f = chooserOpen.getSelectedFile();
                if(f.exists() && f.canRead()) {
                   // "C:/Program files/BibleQuote/RstStrong/BibleQT.ini"
                   IniFileReader(f.getAbsolutePath());
                } else {
                    JOptionPane.showMessageDialog(this,"  : "+f.getAbsolutePath(),"",JOptionPane.ERROR_MESSAGE);
                }
            }
        } catch(Exception e) {
            System.out.println(e.getMessage());
        }
    }//GEN-LAST:event_btnOpenActionPerformed
    
    /**    ini 
     */
    private void IniFileReader(String ini) throws IOException {
        
        //   
        isBible = false;
        
        //   -
        int i = -1;

        //     
        txtPath.setText(ini);
        pathBQModule = ini.substring(0, ini.length()-11);

        //    
        panelBooks.removeAll();
        panelBooks.setLayout(new GridLayout(0,2));
        
        //  ini 
        InputStreamReader f = new InputStreamReader(new FileInputStream(ini),"CP1251");
        BufferedReader reader = new BufferedReader(f);
        String s = null;
        while((s=reader.readLine()) != null) {
            //   , 
            if (s.startsWith("BibleName")) {
                txtModuleName.setText(s.substring(12));
            }
            //    (/ )
            if (s.startsWith("Bible")) {
                isBible = (s.charAt(8) == 'Y');
            }
            //     
            if (s.startsWith("StrongNumbers")) {
                isStrongNumbers = (s.charAt(16) == 'Y');
            }
            //    
            if (s.startsWith("ChapterSign")) {
                chapterSign = s.substring(14);
            }
            //    
            if (s.startsWith("VerseSign")) {
                verseSign = s.substring(12);
            }
            //   ,   
            if (s.startsWith("BookQty")) {
                checkBooks = new JCheckBox[Integer.parseInt(s.substring(10))];
            }
            //   
            if(s.startsWith("FullName")) {
                //  
                i++;
                //       
                checkBooks[i] = new JCheckBox(ShortBookName(s.substring(11)),true);
                panelBooks.add(checkBooks[i]);
            }
        }
        validate();
        reader.close();
        //   
        if (isBible) btnSave.setEnabled(true);
        //    
        txtMidletName.setEnabled(true);
        //   
        radioChoice1.setEnabled(true);
        radioChoice2.setEnabled(true);
        radioChoice3.setEnabled((i>26));
        radioChoice4.setEnabled((i>65));
        //    
        if (i == 26) {
            if (txtModuleName.getText().startsWith("")) 
                txtMidletName.setText(" ");
            else txtMidletName.setText(" ");
        } else txtMidletName.setText("");
        //  
        txtStatus.setText("    "+(i+1)+" .");
    }
    
    /**   
     */
    private String ShortBookName(String bookName) {
        if (bookName.startsWith(" ")) return bookName.substring(2); // " "->""
        if (bookName.startsWith(" ")) return bookName.substring(3); // " "->""
        if (bookName.indexOf('-')>0) return //  - (), 1- (,)
            bookName.substring(0,bookName.indexOf('-'))+bookName.substring(bookName.indexOf('-')+2);
        return bookName;
    }

    /**     ""
     */
    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        try {
            SaveMidletFile(txtMidletName.getText()+".jar"); //   =  
        } catch(Exception e) {
            System.out.println(e.getMessage());
        }
    }//GEN-LAST:event_btnSaveActionPerformed
    
    /**   jBible    
     */
    private void SaveMidletFile(String saveFile) throws IOException {
        
        //   
        FileOutputStream out = new FileOutputStream(saveFile);
        ZipOutputStream zipOut = new ZipOutputStream(out);        
        DataOutputStream dos = new DataOutputStream(zipOut);

        //     (  )
        File fileJAR = new File(saveFile);
        
        //    
        //    
        byte[] buf = new byte[1024];
        final String MIDletName = "MIDlet-Name: ";
        final String MIDlet1 = "MIDlet-1: ";

        //   
        ZipFile jarFile = new ZipFile(JBIBLE_JAR);
        ZipEntry localesFile = new ZipEntry("locale/locales");
        zipOut.putNextEntry(localesFile);
        dos.writeUTF("ru_RU\t\n"); //  /locale/locales
        dos.flush();
        zipOut.closeEntry();
        JarFile distFile = new JarFile(JBIBLE_JAR);
        ZipEntry newEntry = new ZipEntry("locale/ru_RU");
        zipOut.putNextEntry(newEntry);
        JarEntry currEntry = distFile.getJarEntry(MOBILE_DIR+"locale/ru_RU");
        if(currEntry == null) throw new IOException("   "+JBIBLE_JAR+" jar .");
        InputStream is = distFile.getInputStream(currEntry);
        while(is.available()>0) {
            int len = is.read(buf);
            zipOut.write(buf,0,len); //  /locale/ru_RU
        }
        is.close();
        zipOut.closeEntry();
        
        //   
        Enumeration en = jarFile.entries();
        while(en.hasMoreElements()) {
            ZipEntry entry = (ZipEntry)en.nextElement();
            if(entry.getName().startsWith(MOBILE_DIR) //      /mobile
               && (entry.getName().length() > 7) //    "mobile/"
               && !entry.getName().startsWith(MOBILE_DIR+"bible") //    /bible
               && !entry.getName().startsWith(MOBILE_DIR+"locale")) //   
            {
                InputStream inp = jarFile.getInputStream(entry);
                if(entry.getName().equals(MOBILE_DIR+"META-INF/MANIFEST.MF")) {
                    entry = new ZipEntry(entry.getName().substring(7)); //  "mobile/"
                    zipOut.putNextEntry(entry);
                    BufferedReader reader = new BufferedReader(new InputStreamReader(inp,"UTF-8"));
                    OutputStreamWriter writer = new OutputStreamWriter(zipOut,"UTF-8");
                    String line = reader.readLine();
                    while(line!=null) {
                        if(line.startsWith(MIDletName)) line = MIDletName+txtMidletName.getText().trim();
                        if(line.startsWith(MIDlet1)) line = MIDlet1+txtMidletName.getText().trim()+line.substring(line.indexOf(','));
                        writer.write(line+"\n");
                        line = reader.readLine();
                    }
                    writer.flush();
                } else {
                    entry = new ZipEntry(entry.getName().substring(7)); //  "mobile/"
                    zipOut.putNextEntry(entry);
                    while(inp.available()>0) {
                        int len = inp.read(buf);
                        zipOut.write(buf,0,len);
                    }
                }
                inp.close();
            }
        }
        zipOut.closeEntry();

        //   ,   verseCount;
        int verseCount[][];
        int n = 0;
        for(int i=0;i<checkBooks.length;i++) if (checkBooks[i].isSelected()) n++;
        verseCount = new int[n][];
        
        //  ,    
        //    
        //  ini 
        FileReader f = new FileReader(txtPath.getText());
        BufferedReader readini = new BufferedReader(f);
        ArrayList bookNames = new ArrayList(); //  
        ArrayList bibleBook = new ArrayList();
        ArrayList hapterVerses = new ArrayList();
        String contentTXT = null;
        String s = null;
        int i = -1;
        n = 0;
        while((s=readini.readLine()) != null) {
            //    
            if(s.startsWith("PathName")) {
                i++;
                if (checkBooks[i].isSelected()) { //   
                    n++;
                    contentTXT = "";
                    bibleBook.clear();
                    bibleBook = ReadBibleBook(pathBQModule+s.substring(11)); //  
                    verseCount[n-1] = new int[bibleBook.size()]; //    
                    //    jar
                    for(int chapter=0;chapter<bibleBook.size();chapter++) {
                        ZipEntry chaptersBook = new ZipEntry("bible/"+n+"/"+(chapter+1)+".txt");
                        zipOut.putNextEntry(chaptersBook);
                        hapterVerses.clear();
                        hapterVerses = ReadBibleBookChapterVerses((String)bibleBook.get(chapter)); //  
                        verseCount[n-1][chapter] = (int)hapterVerses.size(); //    
                        for(int verse=0;verse<hapterVerses.size();verse++)
                            dos.writeUTF((String)hapterVerses.get(verse)+"\n");
                        zipOut.closeEntry();
                    }
                }
            }
            //   
            if(s.startsWith("ChapterQty")) {
                chapterQty = s.substring(13);
                if (checkBooks[i].isSelected()) //   
                    bookNames.add(checkBooks[i].getText());
            }
        }
        readini.close();

        //   bible/index
        ZipEntry indexFile = new ZipEntry(BIBLE_INDEX);
        zipOut.putNextEntry(indexFile);
        dos.writeByte(bookNames.size()); //  
        //dos.writeInt(bookNames.size()); //  
        for(i=0;i<bookNames.size();i++) {
            dos.writeUTF((String)bookNames.get(i)); //  
            dos.writeByte(verseCount[i].length); //  
            //dos.writeInt(verseCount[i].length); //  
            for (int j=0;j<verseCount[i].length;j++)
                 dos.writeByte(verseCount[i][j]); //    
                 //dos.writeInt(verseCount[i][j]); //    
        }
        dos.flush();
        zipOut.closeEntry();

        //   
        zipOut.close();

        //  
        txtStatus.setText("    "+n+"  ("+(fileJAR.length()/1024)+" ).");
    }

    /**  - 
     *    ,     
     */
    private ArrayList ReadBibleBook(String bookFile) throws IOException {
        ArrayList result = new ArrayList(); //   
        System.out.println(bookFile); //    ()
        FileReader fr = new FileReader(bookFile);
        BufferedReader readbook = new BufferedReader(fr);
        String s;
        String verse = "";
        String chapter = "";
        while((s=readbook.readLine()) != null) {
            //    
            if (s.startsWith(chapterSign)) {
                if (chapter != "") {
                    if (verse != "") {
                        chapter = chapter + verse.trim() + "\n"; //   
                        verse = ""; //  
                    }
                    result.add(chapter); //   
                }
                chapter = "";
            }
            //   
            else if (s.startsWith(verseSign)) {
                if (verse != "") chapter = chapter + verse.trim() + "\n"; //   
                verse = DeleteVNumber(DeleteStrongsN(StripTags(s)));
            } else if ((StripTags(s) != "") && (verse != "")){
                verse = verse.trim() + " " + DeleteStrongsN(StripTags(s)); //  
            }
        }
        readbook.close();
        if (verse != "") chapter = chapter + verse.trim() + "\n"; //   
        result.add(chapter); //   
        return result;
    }
    
    /**     -
     */
    private ArrayList ReadBibleBookChapterVerses(String chapterStr) throws IOException {
        ArrayList result = new ArrayList();//   
        int pointer = 0; //    
        while (pointer < chapterStr.length()) {
            result.add(chapterStr.substring(pointer, chapterStr.indexOf("\n", pointer)));
            pointer = chapterStr.indexOf("\n", pointer)+1;
        }
        return result;
    }
    
    /**  :   
     */
    private String StripTags(String verse) {
        if (verse.indexOf('<')<0) return verse; //    
        String result = "";
        boolean flagRead = true;
        for(int i=0;i<verse.length();i++) {
            if (verse.charAt(i) == '<') flagRead = false;
            else if (verse.charAt(i) == '>') flagRead = true;
            else if (flagRead) result = result + verse.substring(i,i+1);
        }
        return result;
    }
    
    /**  :   
     */
    private String DeleteStrongsN(String verse) {
        if (!isStrongNumbers) return verse; //     
        String result = "";
        verse = verse + " ";
        boolean flagRead = true;
        for(int i=0;i<verse.length()-1;i++) {
            if ((verse.charAt(i) == ' ')&&(verse.charAt(i+1) >= '0')&&(verse.charAt(i+1) <= '9')) flagRead = false;
            else if ((verse.charAt(i) < '0')||(verse.charAt(i) > '9')) flagRead = true;
            if (flagRead) result = result+verse.substring(i,i+1);
        }
        return result.trim();
    }
    
    /**  :   
     */
    private String DeleteVNumber(String verse) {
        return verse.substring(verse.indexOf(' ')+1);
    }
    
    /**    ()  
     */
    private int GetVerseNumbers(String chapter) {
        int result = 1;
        for(int i=0;i<chapter.length();i++)
            if (chapter.charAt(i) == '\n') result++;
        return result;
    }
    
    /**   
     */
    private void btnExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnExitActionPerformed
        System.exit(0);
    }//GEN-LAST:event_btnExitActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new bq2jBible().setVisible(true);
            }
        });
    }
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAbout;
    private javax.swing.JButton btnExit;
    private javax.swing.JButton btnOpen;
    private javax.swing.JButton btnSave;
    private javax.swing.ButtonGroup groupChoice;
    private javax.swing.JLabel labelChoice;
    private javax.swing.JLabel labelMidletName;
    private javax.swing.JLabel labelModuleName;
    private javax.swing.JLabel labelPath;
    private javax.swing.JPanel panelBooks;
    private javax.swing.JPanel panelMidlet;
    private javax.swing.JPanel panelModule;
    private javax.swing.JRadioButton radioChoice1;
    private javax.swing.JRadioButton radioChoice2;
    private javax.swing.JRadioButton radioChoice3;
    private javax.swing.JRadioButton radioChoice4;
    private javax.swing.JScrollPane scrollBooks;
    private javax.swing.JTextField txtMidletName;
    private javax.swing.JTextField txtModuleName;
    private javax.swing.JTextField txtPath;
    private javax.swing.JTextField txtStatus;
    // End of variables declaration//GEN-END:variables
    
}